(*	esercizio 2.6 pagina 47 del testo
	Algoritmi e Strutture Dati (Alan Bertossi)

	versione RICORSIVA
*)

Program PariEDispari;

(* struttura della lista bidirezionale NON ciclica *)
type	puntacella = ^cella;
	cella = record
		precedente : puntacella;
		valore : integer;
		successivo : puntacella
	end;

(* puntatori alla testa e alla coda della lista *)
var	testa, coda : puntacella;

(* inserimento di un valore *)
Procedure Inserisci(numero : integer);
Begin
	(* lista vuota *)
	if testa = NIL then
	Begin
		new(testa);
		testa^.precedente:=NIL;
		testa^.valore:=numero;
		testa^.successivo:=NIL;
		coda := testa
	End else (* lista non vuota *)
	Begin
		new(coda^.successivo);
		coda^.successivo^.precedente:=coda;
		coda^.successivo^.valore:=numero;
		coda^.successivo^.successivo:=NIL;
		coda:=coda^.successivo
	End;

End;

(* inserimento di una cella gi allocata, utile per
spostare cella in coda alla lista *)
Procedure InserisciCella(box : puntacella);
Begin
	(* suppongo che la lista non sia vuota *)
	coda^.successivo := box;
	box^.precedente := coda;
	box^.successivo := NIL;
	coda := box
End;

(* visita della lista *)
Procedure Visita();
var ptmp : puntacella;
Begin
	ptmp := testa;
	while ptmp<>NIL do
	Begin
		write(ptmp^.valore,' ');
		ptmp := ptmp^.successivo
	End;

	(* indica il valore di testa e di coda della lista *)
	writeln(' -> ', testa^.valore, ':', coda^.valore)
End;

(* popolamento della lisa iniziale *)
Procedure Popola(numero : integer);
var tempo : integer;
Begin

	(* inizializzazione del generatore di numeri pseudocasuali *)
	Randomize();
	for tempo:=1 to numero do
		Inserisci(Random(100)+1)

(*	versione NON casuale, utile per il debug
	for tempo:=1 to numero do
		Inserisci(tempo) 
*)

End;

(* rimuove una cella dalla lista *)
Function Rimuovi(elemento : puntacella) : puntacella;
Begin
	(* elemento di testa *)
	if elemento^.precedente = NIL then
	Begin
		testa := testa^.successivo;
		testa^.precedente := NIL
	End else
	(* elemento di coda *)
	if elemento^.successivo = NIL then
	Begin
		elemento^.precedente^.successivo := NIL
	End else
	(* elemento centrale *)
	Begin
		elemento^.precedente^.successivo := elemento^.successivo;
		elemento^.successivo^.precedente := elemento^.precedente
	End;

	(* restituisce il puntatore alla cella rimossa *)
	Rimuovi := elemento
End;

(* verifica se un numero  dispari *)
Function Dispari(numero:integer) : boolean;
Begin

	(* se  divisibile per 2 allora  pari, lo 0 non  previsto
	come input *)
     	if (numero mod 2) = 0 then
		Dispari:=false
	else	Dispari:=true
End;

(* dato il puntatore ad una cella, provvede ad eliminarla dalla
posizione attuale e collocarla in fondo alla lista *)
Procedure Scambia(box : puntacella);
Begin
	InserisciCella(Rimuovi(box));

	(* visita per debug *)
	Visita()
End;

(* analisi passo passo degli elementi della lista per determinare
la loro posizione a seconda che siano pari o dispari *)
Procedure Elabora(endcoda : puntacella; var testa, coda : puntacella);

(* parametri: coda iniziale della lista, testa della lista, coda della lista *)
var 	tempo : puntacella;
	prossimo : puntacella;
Begin
     	tempo := testa;

    	if tempo <> endcoda then
	Begin	(* non sono in coda alla lista *)

		(* scambio di celle e chiamata ricorsiva *)
                prossimo := tempo^.successivo;
     		if not Dispari(tempo^.valore) then Scambia(tempo);
		tempo := prossimo;
	        Elabora(endcoda, tempo, coda)
	End else
	if tempo = endcoda then
    	Begin(* sono in coda alla lista manca l'ultima chiamata *)
             	prossimo := tempo^.successivo;
                if not Dispari(tempo^.valore) then Scambia(tempo)
        End
End;

Begin
	testa := NIL; coda:=NIL;
	Popola(11);
	Visita();
	Elabora(coda, testa, coda)
End.

